<script lang="ts">
  import { numberWithCommas } from "src/functions/comma-number";
  import Splide from "@splidejs/splide";

  import type { CartProductModel } from "src/models/cart.product.type";
  import type {
    ProcuteImgModel,
    ProductModel,
    ProductOptionModel,
  } from "src/models/product.type";
  import { Page } from "src/page";
  import {
    productSelectedStore,
    pageSelectedStore,
    cartOrdersStore,
    userProfileStore,
  } from "src/store";
  import AlertMessage from "src/widgets/AlertMessage";
  import { onMount } from "svelte";

  let productOptionSelected: ProductOptionModel;

  const imageList: ProcuteImgModel[] = $productSelectedStore.image || [];

  function addToCart(product: ProductModel) {
    if (
      !productOptionSelected ||
      Object.values(productOptionSelected).length == 0
    ) {
      AlertMessage.alert("กรุณาเลือกตัวเลือกสินค้าก่อน");
    } else {
      if (productOptionSelected.instock > 0) {
        const itemCart: CartProductModel = {
          id: Date.now().toString(),
          productId: product.productId,
          optionSelect: productOptionSelected,
          productName: product.productName,
          image: product.image[0].url,
          desc: product.productDesc,
          discount: product.discount,
          price: product.price,
          amount: product?.amount || 1,
          sumPrice:
            (product.price - (product.price * product.discount) / 100) *
            (product?.amount || 1),
          selected: true,
        };

        if (!$cartOrdersStore) {
          $cartOrdersStore = [];
        }

        // ตรวจสอบว่าสินค้าที่เลือก ว่ามีตัวเลือกซ้ำกันกับในตะกร้าไหม
        const hasOptionInCart = $cartOrdersStore
          ? $cartOrdersStore.find(
              (product) => product.optionSelect == itemCart.optionSelect
            )
          : false;

        // ถ้าไม่มีให้ Add to Cart
        if (!hasOptionInCart) {
          $cartOrdersStore.push(itemCart);
          $cartOrdersStore = $cartOrdersStore;
        }

        // ตรวจสอบว่าตอนเพิ่มสินค้าลงตะกร้า มีการเข้าสู่ระบบยัง ถ้ายังต้องเข้าระบบก่อน
        if (!$userProfileStore) {
          $pageSelectedStore = Page["LOGIN"];
        }
      } else {
        AlertMessage.alert("ไม่มีสินค้า กรุณาเลือกตัวเลือกใหม่");
      }
    }
  }

  function onSelectOption(option: ProductOptionModel) {
    productOptionSelected = option;
  }

  let secondarySlider, primarySlider;

  onMount(() => {
    if (imageList.length) {
      secondarySlider = new Splide("#secondary-slider", {
        rewind: true,
        fixedWidth: 60,
        fixedHeight: 60,
        isNavigation: true,
        gap: 10,
        focus: "center",
        pagination: false,
        cover: true,
        breakpoints: {
          "600": {
            fixedWidth: 66,
            fixedHeight: 40,
          },
        },
      }).mount();

      primarySlider = new Splide("#primary-slider", {
        type: "fade",
        heightRatio: 0.5,
        pagination: false,
        arrows: false,
        cover: true,
      });

      primarySlider.sync(secondarySlider).mount();
    }
  });
</script>

<div class="flex h-94 bg-gray-400 justify-center">
  <div class="flex flex-col p-10">
    <div
      id="primary-slider"
      class="splide flex justify-center bg-gray-900 rounded-t"
    >
      <div class="splide__track">
        <ul class="splide__list">
          {#each imageList as imageFile}
            <li class="splide__slide w-64 h-64">
              <img
                class="w-64 h-64 border border-gray-400 bg-white rounded shadow cursor-pointer"
                alt="img"
                src={imageFile.url}
              />
            </li>
          {/each}
        </ul>
      </div>
    </div>
    <div id="secondary-slider" class="splide w-full bg-gray-500 rounded-b">
      <div class="splide__track">
        <ul class="splide__list">
          {#each imageList as imageFile}
            <li class="splide__slide">
              <img
                class="border-gray-400 bg-white rounded m-2 p-2 shadow cursor-pointer"
                alt="img"
                src={imageFile.url}
              />
            </li>
          {/each}
        </ul>
      </div>
    </div>
  </div>

  <div class="px-10 bg-white rounded shadow-lg mx-10 my-5">
    <div class="flex justify-between mt-3 border-b border-gray-300">
      <svg
        on:click={() => ($pageSelectedStore = Page["PRODUCTS_LIST"])}
        class="h-14 py-2 px-5 cursor-pointer hover:text-red-500"
        xmlns="http://www.w3.org/2000/svg"
        fill="none"
        viewBox="0 0 24 24"
        stroke="currentColor"
      >
        <path
          stroke-linecap="round"
          stroke-linejoin="round"
          stroke-width="2"
          d="M15 19l-7-7 7-7"
        />
      </svg>
      <p class="py-2 font-bold text-lg">รายละเอียดสินค้า</p>
      <p class="py-2 px-14" />
    </div>
    <div class="flex justify-center items-center mt-3 flex-col">
      <p class="py-2 font-bold text-lg">ตัวเลือกสินค้า</p>
      {#if productOptionSelected}
        <div class="flex justify-end px-5">
          <p class="text-green-500 text-x">
            มีสินค้าทั้งหมด <span class="text-xl"
              >{numberWithCommas(productOptionSelected.instock)}</span
            > ชิ้น
          </p>
        </div>
      {/if}

      <div class="flex py-2 relative ">
        {#each $productSelectedStore?.productOptions || [] as option, index}
          <button
            on:click={() => onSelectOption(option)}
            class="{productOptionSelected?.productName == option?.productName
              ? 'bg-green-600 text-white'
              : 'text-gray-500'} inline-flex overflow-visible relative justify-center items-center py-1 px-3 mt-0 mr-2 mb-2 ml-0 leading-4 text-left normal-case bg-white rounded-sm border border-solid cursor-pointer box-border"
            style="min-width: 5rem; min-height: 2.125rem; outline: 0px; word-break: break-word;"
          >
            {index + 1}. {option.productName}

            {#if productOptionSelected?.productName == option?.productName}
              <div
                class="overflow-hidden absolute right-0 bottom-0 w-6 h-6 text-left cursor-pointer"
                style="word-break: break-word;"
              >
                <svg
                  enable-background="new 0 0 12 12"
                  viewBox="0 0 12 12"
                  x="0"
                  y="0"
                  class="inline-block absolute right-0 bottom-0 w-4 h-4 text-white p-1"
                  style="fill: currentcolor; font-size: 8px; line-height: 9.6px; word-break: break-word;"
                >
                  <g
                    class=""
                    style="font-size: 8px; line-height: 9.6px; word-break: break-word;"
                  >
                    <path
                      d="m5.2 10.9c-.2 0-.5-.1-.7-.2l-4.2-3.7c-.4-.4-.5-1-.1-1.4s1-.5 1.4-.1l3.4 3 5.1-7c .3-.4 1-.5 1.4-.2s.5 1 .2 1.4l-5.7 7.9c-.2.2-.4.4-.7.4 0-.1 0-.1-.1-.1z"
                      class=""
                      style="font-size: 8px; line-height: 9.6px; word-break: break-word;"
                    />
                  </g>
                </svg>
              </div>
            {/if}
          </button>
        {/each}
      </div>
    </div>
    <div class="flex px-10 justify-end">
      <div class="flex items-center justify-between ">
        <p class="text-red-500 font-bold text-2xl">
          {#if $productSelectedStore.discount > 0}
            <span class="mr-1 text-base leading-5 text-gray-400 line-through">
              ฿{$productSelectedStore.price}
            </span>
          {/if}
          ฿{numberWithCommas(
            $productSelectedStore.price -
              ($productSelectedStore.price * $productSelectedStore.discount) /
                100
          )}
        </p>
        <span class="text-gray-600 text-sm">/ ชิ้น</span>
      </div>
    </div>
    <div class="flex px-10 flex-col">
      <p class="py-2 font-bold text-gray-600">รายละเอียด</p>
      <p class="py-2 font-bold text-gray-400 px-10">
        {$productSelectedStore.productDesc}
      </p>
    </div>

    <div class="flex justify-center mt-3 border-t border-gray-300 py-2">
      <div class="flex leading-4 text-gray-800 py-2">
        <button
          on:click={() => addToCart($productSelectedStore)}
          type="button"
          class="flex overflow-hidden flex-row justify-center items-center py-0 px-3 my-0 mr-4 ml-0 h-12 text-sm text-center text-red-600 capitalize bg-orange-100 rounded-sm border border-red-600 border-solid cursor-pointer box-border shadow-xs hover:bg-pink-200"
          aria-disabled="false"
          style="text-overflow: ellipsis; outline: 0px; min-width: 11.25rem; max-width: 250px;"
        >
          <svg
            enable-background="new 0 0 15 15"
            viewBox="0 0 15 15"
            x="0"
            y="0"
            class="inline-block relative mr-2 w-4 h-4 text-xl leading-6 capitalize"
            style="fill: currentcolor; stroke: rgb(238, 77, 45);"
          >
            <g class="capitalize">
              <g class="capitalize">
                <polyline
                  fill="none"
                  points=".5 .5 2.7 .5 5.2 11 12.4 11 14.5 3.5 3.7 3.5"
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  stroke-miterlimit="10"
                  class="capitalize"
                />
                <circle
                  cx="6"
                  cy="13.5"
                  r="1"
                  stroke="none"
                  class="capitalize"
                />
                <circle
                  cx="11.5"
                  cy="13.5"
                  r="1"
                  stroke="none"
                  class="capitalize"
                />
              </g>
              <line
                fill="none"
                stroke-linecap="round"
                stroke-miterlimit="10"
                x1="7.5"
                x2="10.5"
                y1="7"
                y2="7"
                class="capitalize"
              />
              <line
                fill="none"
                stroke-linecap="round"
                stroke-miterlimit="10"
                x1="9"
                x2="9"
                y1="8.5"
                y2="5.5"
                class="capitalize"
              />
            </g></svg
          ><span class="text-red-600 capitalize">เพิ่มไปยังรถเข็น</span></button
        >
        <button
          on:click={() => ($pageSelectedStore = Page["CART"])}
          class="flex overflow-visible relative justify-center items-center py-2 px-10 m-0 text-sm font-light tracking-normal leading-none text-center text-white normal-case bg-red-600 cursor-pointer select-none shadow-xs hover:bg-red-600 focus:bg-red-600 focus:shadow-xs"
          style="outline: none; transition: opacity 0.2s ease 0s;"
        >
          <span class="text-base leading-4 text-white capitalize"
            >ดูรถเข็นของคุณ</span
          >
        </button>
      </div>
    </div>
  </div>
</div>
